// author: Chuck Baker
// Version 10.0

//		Common (global) variables
var Cc = Components.classes;
var Ci = Components.interfaces;
Components.utils.import("resource://gre/modules/AddonManager.jsm");

// Get pointer to preferences
	try{
		var cleoPrefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("");
	}catch(e){ alert(e);}

function cleoGetUnicharPref(prefName) {
    return cleoPrefs.getComplexValue(prefName, Ci.nsISupportsString).data;
}

function cleoSetUnicharPref(prefName, prefValue) {
    var supportsString = Cc["@mozilla.org/supports-string;1"].createInstance(Ci.nsISupportsString);
    supportsString.data = prefValue;
    cleoPrefs.setComplexValue(prefName, Ci.nsISupportsString, supportsString);

} 

// Set global variables
	var cleoExtName = new String();					// Extension name
	var cleoMsg = [];								// Array holding localized strings
	var cleoPathList = [];							// Array holding paths to items to process
	var cleoFileList = [];							// Array holding names of items to process
	var cleoDesc = [];								// Lines of package description
	var cleoExtBUdir = new String;					// Directory where the results are stored
	var cleoPackageName = new String();				// Name of finished package
	var cleoViewPackageName = new String();			// Name of package to view info
	var cleoFilesToAnalizeDir = new String();		// Path to "filesToAnalize" in temp dir
	var cleoFilesToPackageDir = new String();		// Path to "filesToPackage" in temp dir
	var cleoTmpDir = new String()					// nsI pointer to [temp]/febe.tmp/cleo.tmp
	var cleoTmpDirName = new String();				// Name of Firefox temp directory
	var cleoWin = new String();						// Cleo main window
	var cleoItems									// Number of items tp process
	var cleoVersion = new String();					// Version of this extension
	var cleoInstallDir = new String();	// Folder where CLEO is installed
	var cleoPackageDesc = new String();				// Package description
	var cleoOverwriteOpt = new Number;				// Overwrite package option
	var cleoRewriteInfoFlag = new Boolean(false);	// Rebuild the comment file?
	var cleoInfoFileFlag = new Boolean(false);		// Processing view info function?
	var cleoHideHelp = new Boolean(false);			// Hide help icons?
	
	var CLEO_GUID = "CLEO@guid.customsoftwareconsult.com"  // GUID of this extension
	var cFEBE_GUID = "{4BBDD651-70CF-4821-84F8-2B918CF89CA3}"  // FEBE's GUID

function cleoLocalize(){
  // Set localized variables
	var cs = document.getElementById('cleo-strings');
	if(!cs) {	// Can't find it?  Try looking for the CLEO Options window
		var wm = Cc["@mozilla.org/appshell/window-mediator;1"] .getService(Ci.nsIWindowMediator); 
		var enumerator = wm.getEnumerator("cleo:options"); 
		while(enumerator.hasMoreElements()) { 
			var win = enumerator.getNext(); 
			cs = win.document.getElementById('cleo-strings');			
		}//while 
	}//if
	if(!cs){return false;}	// If it still fails, we probably don't need it anyway.
	var enumerator = cs.strings;
	var cnt=0;
	var id="";
	while (enumerator.hasMoreElements()) {
		if(cnt > 9){
			id = cnt.toString();
		}else{
			id = "0" + cnt.toString();
		}// if
		var msg = "msg"+id;
		try{
			cleoMsg.push(cs.getString(msg));
		}catch(e){;}
		enumerator.getNext();
		cnt++;
	}//while
	return true;
}//cleoLocalize()
	
function getCleoVersion(){
	AddonManager.getAddonByID(CLEO_GUID, function(addon){
		Application.storage.set("cleoVersion", addon.version);
		return true;
	});
}//getCleoVersion()

function setCleoVersion(){
	//cleoLocalize();
	cleoVersion = Application.storage.get("cleoVersion", "???");
	document.getElementById("cleoAboutVersionID").value = cleoVersion;
	return true;
}//setCleoVersion()

function cleoAlert(message){
	cleoWin = window.openDialog("chrome://cleo/content/cleoAlert.xul", "CLEO Alert", "chrome,modal,dialog=yes,alwaysRaised,resizable,titlebar=no,popup=yes",message);	
	cleoWin.focus();
	return true;
}//cleoAlert()

function cleoHelp(helpIndex,fieldName){
	var cleoWin = window.openDialog("chrome://cleo/content/cleoHelp.xul", "CLEO Help", "chrome,dialog=yes,alwaysRaised,resizable,titlebar=no,popup=yes",helpIndex,fieldName);
	cleoWin.focus();
	return true;
}//cleoHelp()

function cleoObj(name, version, description, author, fxminver, fxmaxver, homepage){
	this.name = name;
	this.version = version;
	this.description = description;
	this.author = author;
	this.fxminver = fxminver;
	this.fxmaxver = fxmaxver;
	this.homepage = homepage;
	return true;
}//cleoObj()

function cleoTmpName(){
  // Return a random filename
  return "CLEO"+Math.floor(Math.random() * 1e+8)+".xpi";
}//cleoTmpName()

function cleoOptions(aPaneID){
	window.openDialog('chrome://cleo/content/cleoOptions.xul', 'CLEO Options', 'chrome,titlebar,toolbar,centerscreen,resizable');	
}//cleoOptions()

function cleoViewInfo(){
	window.openDialog('chrome://cleo/content/cleoViewInfo.xul', 'CLEO ViewInfo', 'chrome,centerscreen,resizable,dependent');	
}//cleoViewInfo()

function cleoMakePath(dir, file){
  // Return the path of file appended to dir
	var aFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	aFile.initWithPath(dir);
	aFile.append(file);
	return aFile.path;
}//cleoMakePatth()


//alert("cleoCommon.js loaded");
